PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Protected Member Functions | List of all members
PArray< T > Class Template Reference

This template class maps the `PArrayObjects` to a specific object type. More...

`#include <array.h>`

Inheritance diagram for PArray< T >:
[legend]
Collaboration diagram for PArray< T >:
[legend]

## Public Member Functions
Construction
| PArray (PINDEX initialSize=0)
| Create a new array of objects. More...
Overrides from class PObject
virtual PObject * | Clone () const
| Make a complete duplicate of the array. More...
New functions for class
T & | operator[] (PINDEX index) const
| Retrieve a reference to the object in the array. More...
Public Member Functions inherited from PArrayObjects
PINLINE | PArrayObjects (PINDEX initialSize=0)
| Create a new array of objects. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two arrays. More...
virtual PINDEX | GetSize () const
| Get size of array. More...
virtual PBoolean | SetSize (PINDEX newSize)
| Set the size of the array in objects. More...
virtual PINDEX | Append (PObject *obj)
| Append a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Insert a new object immediately before the specified object. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified ordinal index. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| PArray (int dummy, const PArray *c)

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Protected Attributes inherited from PArrayObjects
PBaseArray< PObject * > * | theArray
Friends inherited from PObject

## Detailed Description

### template<class T>
class PArray< T >

This template class maps the `PArrayObjects` to a specific object type.

The functions in this class primarily do all the appropriate casting of types.

Note that if templates are not used the `PARRAY` macro will simulate the template instantiation.

## Constructor & Destructor Documentation

template<class T>

PArray< T >::PArray | ( | PINDEX | initialSize = `0` | ) |
| inline

Create a new array of objects.

The array is initially set to the specified size with each entry having NULL as is pointer value.

Note that by default, objects placed into the list will be deleted when removed or when all references to the list are destroyed.

Parameters

  initialSize | Initial number of objects in the array.

Referenced by PArray< PODBC::Field >::Clone().

template<class T>

PArray< T >::PArray | ( | int | dummy,
|  | const PArray< T > * | c
| ) |  |
| inline protected

## Member Function Documentation

template<class T>

virtual PObject* PArray< T >::Clone | ( |  | ) | const
| inline virtual

Make a complete duplicate of the array.

Note that all objects in the array are also cloned, so this will make a complete copy of the array.

Reimplemented from PObject.

Reimplemented in PStringArray.

template<class T>

T& PArray< T >::operator[] | ( | PINDEX | index | ) | const
| inline

Retrieve a reference to the object in the array.

If there was not an object at that ordinal position or the index was beyond the size of the array then the function asserts.

Returns
  Reference to the object at `index` position.

Parameters

  index | Index position in the collection of the object.

The documentation for this class was generated from the following file:

- array.h